%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

Name:		rh-rhua
Version:	0.80
Release:	1%{?dist}
Summary:	Functionality to act as a Red Hat Update Appliance in any supported cloud

Group:		Applications/Internet
License:	GPLv2
URL:		http://redhat.com
Source0:	%{name}-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:	python-setuptools
Requires:       httpd >= 2.2.3-40
Requires:	python >= 2.4
Requires:       PyYAML
Requires:       iptables
Requires:       coreutils
Requires:       grinder

%description
Tools necessary to function as a Red Hat Update Appliance.

%prep
%setup -q -n rh-rhua-%{version}


%build
%{__python} setup.py build


%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT%{python_sitelib}/*egg-info/requires.txt

# Configuration
mkdir -p $RPM_BUILD_ROOT/etc/rhua
cp -R $RPM_BUILD_DIR/%{name}-%{version}/etc/rhua/* $RPM_BUILD_ROOT/etc/rhua/

# Cron Jobs
mkdir $RPM_BUILD_ROOT/etc/cron.d
cp $RPM_BUILD_DIR/%{name}-%{version}/etc/cron.d/*.cron $RPM_BUILD_ROOT/etc/cron.d/

# Firewall
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
cp $RPM_BUILD_DIR/%{name}-%{version}/etc/sysconfig/iptables.rhua $RPM_BUILD_ROOT/etc/sysconfig/

# Man Page
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man1
cp $RPM_BUILD_DIR/%{name}-%{version}/usr/share/man/man1/rhua.1 $RPM_BUILD_ROOT/usr/share/man/man1

# Logging
mkdir -p $RPM_BUILD_ROOT/var/log/rhua


%clean
rm -rf $RPM_BUILD_ROOT


%post
# Firewall
touch /etc/sysconfig/iptables
mv /etc/sysconfig/iptables /etc/sysconfig/iptables.prerhua
cp /etc/sysconfig/iptables.rhua /etc/sysconfig/iptables
/sbin/service iptables restart


%files
%defattr(-,root,root,-)
%doc /usr/share/man/man1/rhua.1.gz
%{python_sitelib}/rhua/*
%{python_sitelib}/rhua-*.egg-info
%{_bindir}/rhua
/var/log/rhua
%config            %{_sysconfdir}/rhua/config.yml.example
%config            %{_sysconfdir}/rhua/cds-template.repo
%config(noreplace) %{_sysconfdir}/rhua/rhua.yml
%config            %{_sysconfdir}/rhua/cds/ssl.conf 
%config            %{_sysconfdir}/rhua/cds/cds_ssl.conf 
%config            %{_sysconfdir}/rhua/cds/yum_ssl.conf 
%config            %{_sysconfdir}/sysconfig/iptables.rhua
%config(noreplace) %{_sysconfdir}/cron.d/rhua_update.cron
%config(noreplace) %{_sysconfdir}/cron.d/rhua_monitor.cron


%changelog
* Fri Aug 13 2010 Jay Dobies <jason.dobies@redhat.com> 0.80-1
- Updated monitor to test the load balancer. Updated tools to require the load
  balancer DNS entry. (jason.dobies@redhat.com)

* Thu Aug 12 2010 Jay Dobies <jason.dobies@redhat.com> 0.79-1
- 

* Thu Aug 12 2010 Jay Dobies <jason.dobies@redhat.com> 0.78-1
- Refactored load balancer configuration in tools to be able to create an RPM
  to configure an external load balancer (i.e. not embedded in the RHUA).
  Updated the RHUA code to check to see if the embedded load balancer should be
  started/stopped. (jason.dobies@redhat.com)
- Added https to firewall configuration. (jason.dobies@redhat.com)

* Wed Aug 11 2010 Jay Dobies <jason.dobies@redhat.com> 0.77-1
- Removed mirror list functionality and replaced with load balancer start/stop
  calls (jason.dobies@redhat.com)

* Fri Aug 06 2010 Jay Dobies <jason.dobies@redhat.com> 0.76-1
- Increased the default time between monitoring checks. With the addition of
  the RHUI channels to the mix, I think the yum tests are taking longer than 2
  minutes (the old time between checks) to execute and they are starting to
  step on each other with yum lock errors. (jason.dobies@redhat.com)

* Wed Aug 04 2010 Jay Dobies <jason.dobies@redhat.com> 0.75-1
- 621094 - Added call to remove all packages from the CDS on an environment
  destroy. (jason.dobies@redhat.com)
- 621054 - The test mirror list call was in an except block when being called
  from summary, but not monitor. (jason.dobies@redhat.com)
- Fixed bug in error message. (jason.dobies@redhat.com)

* Tue Aug 03 2010 Jay Dobies <jason.dobies@redhat.com> 0.74-1
- Moved all logging to /var/log/rhua (jason.dobies@redhat.com)

* Tue Aug 03 2010 Jay Dobies <jason.dobies@redhat.com> 0.73-1
- 620890 - Changed yum output location to /var/log (jason.dobies@redhat.com)
- 620887 - Changed log file handlers to automatically rotate based on a
  configurable size. (jason.dobies@redhat.com)

* Tue Aug 03 2010 Jay Dobies <jason.dobies@redhat.com> 0.72-1
- Fixes for monitoring in new single-cert environment.
  (jason.dobies@redhat.com)

* Tue Aug 03 2010 Jay Dobies <jason.dobies@redhat.com> 0.71-1
- Removed the multiple entitlement cert requests from tools. RHUA/Tools now
  expects to deal with a single cert for all channels for monitoring. This is
  more consistent with how tools generates the certs; in the future we can
  revisit this if tools is to generate multiple certs.
  (jason.dobies@redhat.com)

* Mon Aug 02 2010 Jay Dobies <jason.dobies@redhat.com> 0.70-1
- Sync the RHUI channels as well (jason.dobies@redhat.com)

* Mon Aug 02 2010 Jay Dobies <jason.dobies@redhat.com> 0.69-1
- Pass "newest" flag to grinder to only get the latest versions of packages
  (jason.dobies@redhat.com)

* Fri Jul 30 2010 Jay Dobies <jason.dobies@redhat.com> 0.68-1
- Added proxy support for package sync (jason.dobies@redhat.com)

* Fri Jul 30 2010 Jay Dobies <jason.dobies@redhat.com> 0.67-1
- 619635 - Heartbeat was using the channel name instead of the URL to look for
  the mirror list. (jason.dobies@redhat.com)
- 619163 - Changed wording in unconfigured state to indicate to install the
  configuration RPM instead of the now-disabled config command.
  (jason.dobies@redhat.com)

* Fri Jul 30 2010 Jay Dobies <jason.dobies@redhat.com> 0.66-1
- 619631 - Somewhere between grinder and yum the channel name is added to the
  end of the basepath to save packages. So passing in an empty channel name
  here prevents that extra level in the hierarchy. (jason.dobies@redhat.com)

* Thu Jul 29 2010 Jay Dobies <jason.dobies@redhat.com> 0.65-1
- *ahem* The URL concatenation doesn't like a trailing slash on the hostname.
  (jason.dobies@redhat.com)

* Wed Jul 28 2010 Jay Dobies <jason.dobies@redhat.com> 0.64-1
- Fixed base sync directory for grinder (jason.dobies@redhat.com)

* Wed Jul 28 2010 Jay Dobies <jason.dobies@redhat.com> 0.63-1
- Fixes for hosted CDS (jason.dobies@redhat.com)

* Wed Jul 28 2010 Jay Dobies <jason.dobies@redhat.com> 0.62-1
- Changed RHUI to use hosted CDS instead of RHN. Changes include RHUA changes
  to use yum instead of RHN sync and to the tools to package the appropriate
  certs needed for the connection. (jason.dobies@redhat.com)

* Mon Jul 26 2010 Jay Dobies <jason.dobies@redhat.com> 0.61-1
- Updated mirror list checking to use the new-style URLs
  (jason.dobies@redhat.com)

* Mon Jul 26 2010 Jay Dobies <jason.dobies@redhat.com> 0.60-1
- Updated the mirror list URLs on the RHUA to match what will be in the content
  certificates. (jason.dobies@redhat.com)

* Mon Jul 26 2010 Jay Dobies <jason.dobies@redhat.com> 0.59-1
- Updated config for HTTPS monitoring to use the correct location for the CA
  cert. (jason.dobies@redhat.com)
- RHUI tools is placing this file at ca.crt, so updating this configuration to
  match. (jason.dobies@redhat.com)

* Thu Jul 22 2010 Jay Dobies <jason.dobies@redhat.com> 0.58-1
- 616388 - Incorrect parameter from heartbeat. (jason.dobies@redhat.com)

* Tue Jul 20 2010 Jay Dobies <jason.dobies@redhat.com> 0.57-1
- Changed URLs of repos to match the Red Hat standard download URL locations
  (jason.dobies@redhat.com)

* Fri Jul 16 2010 Jay Dobies <jason.dobies@redhat.com> 0.56-1
- Added check to make sure the channel path doesn't already exist before trying
  to create it. (jason.dobies@redhat.com)
- Fixed monitoring to use the new style channel URLs (jason.dobies@redhat.com)

* Thu Jul 15 2010 Jay Dobies <jason.dobies@redhat.com> 0.55-1
- Updated with RHUI tools additions (jason.dobies@redhat.com)

* Wed Jul 14 2010 Jay Dobies <jason.dobies@redhat.com> 0.54-1
- Changed destination of repo packages to comply with entitlement certificate download URLs (jason.dobies@redhat.com)

* Fri Jul 02 2010 Jay Dobies <jason.dobies@redhat.com> 0.53-1
- Fixed channel monitoring (jason.dobies@redhat.com)

* Fri Jul 02 2010 Jay Dobies <jason.dobies@redhat.com> 0.52-1
- Finally fixed the issue where the sync_base configuration value has to end
  with a trailing slash. (jason.dobies@redhat.com)
- Fixed missing variable assignment in non-deltacloud run
  (jason.dobies@redhat.com)

* Thu Jul 01 2010 Jay Dobies <jason.dobies@redhat.com> 0.51-1
- Added option to disable automatic CDS configuration.
  (jason.dobies@redhat.com)
- Made more tolerant of running without deltacloud (jason.dobies@redhat.com)

* Mon Jun 14 2010 Jay Dobies <jason.dobies@redhat.com> 0.50-1
- bug fix for bz# 601167 (skarmark@redhat.com)

* Mon Jun 07 2010 Sayli Karmarkar <skarmark@redhat.com> 0.49-1
- bug fix for bz# 601167 (skarmark@redhat.com)

* Wed Jun 02 2010 Jay Dobies <jason.dobies@redhat.com> 0.48-1
- 599023 - Changed yum repo checking to do a check per channel. Added better
  clean up logic to get rid of the temporary repo files.
  (jason.dobies@redhat.com)
- 598999 - Updated to have the SSL context pick the entitlement certificate
  based on the channel it is trying to connect to. (jason.dobies@redhat.com)

* Tue Jun 01 2010 Jay Dobies <jason.dobies@redhat.com> 0.47-1
- 598635 - Fixed incorrect yum command for testing CDS connectivity
  (jason.dobies@redhat.com)

* Fri May 28 2010 Jay Dobies <jason.dobies@redhat.com> 0.46-1
- 597327 - Increased logging for CDS HTTP check. Changed yum handling of
  specific test repos. (jason.dobies@redhat.com)
- 597294 - Generate the mirror list entries from the hostnames configured in
  config.yml, not the actual ones. (jason.dobies@redhat.com)

* Wed May 26 2010 Jay Dobies <jason.dobies@redhat.com> 0.45-1
- 595759 - Added "refresh" command to force pushing packages out to CDS
  instances. (jason.dobies@redhat.com)
- 596348 - Fixed incorrect directory entries. (jason.dobies@redhat.com)
- 596406, 596106 - Removed 'rhua monitor' from being displayed as a user
  runnable command. This should just be run by the cron job.
  (jason.dobies@redhat.com)

* Mon May 24 2010 Sayli Karmarkar <skarmark@redhat.com> 0.44-1
- Fixed incorrect method signature (jason.dobies@redhat.com)
- Fixing couple of issues with rhua stop (skarmark@redhat.com)
- Fixing couple of issues with rhua start (skarmark@redhat.com)
- Adding deltacloud credentials and region to interactive config
  (skarmark@redhat.com)
- rhua start can now be invoked multiple time without adding extra CDS
  instances (skarmark@redhat.com)

* Fri May 21 2010 Jay Dobies <jason.dobies@redhat.com> 0.42-1
- Removed unused dep (jason.dobies@redhat.com)
- Yanked out the Red Hat specific monitoring solution pieces.
  (jason.dobies@redhat.com)
- rhua start can now be invoked multiple time without adding extra CDS
  instances (skarmark@redhat.com)
- Adding cds_options to interactive config (skarmark@redhat.com)

* Thu May 20 2010 Jay Dobies <jason.dobies@redhat.com> 0.38-1
- CDS package directory is now different from the directory apache will serve
  them from. There is now a symlink created to link the two.
  (jason.dobies@redhat.com)
- Added httpd start to mirrorlist creation (jason.dobies@redhat.com)
- Oops, line was placed at the wrong spot. (jason.dobies@redhat.com)
- Made the manual steps logged a little more primonently.
  (jason.dobies@redhat.com)
- Massive refactoring of amazon tools to extract out the amazon portions. Added
  CDS creation as part of the nimbus_setup call. (jason.dobies@redhat.com)
- os import error fixed (skarmark@redhat.com)
- Fixing bug in the previous commit (skarmark@redhat.com)
- Adding deltacloud instance creation options to config as they are different
  for each driver (skarmark@redhat.com)
- Adding function to terminate cds instances associated with rhua based on
  mirror list (skarmark@redhat.com)

* Wed May 19 2010 Jay Dobies <jason.dobies@redhat.com> 0.36-1
- Added yum tests against the CDS instances. (jason.dobies@redhat.com)
- Need to fetch the repo file, not just a directory listing (which is
  forbidden) (jason.dobies@redhat.com)
- Updates to monitoring to support better RHUA checking and live connection to
  a CDS instance. (jason.dobies@redhat.com)

* Tue May 18 2010 Jay Dobies <jason.dobies@redhat.com> 0.35-1
- Added indication of the manual step of mapping the generated CDS instances to
  the configurations they were given. (jason.dobies@redhat.com)
- Minor logging fixes (jason.dobies@redhat.com)

* Mon May 17 2010 Jay Dobies <jason.dobies@redhat.com> 0.34-1
- Added translation step between prompt display values and cloud driver names
  (jason.dobies@redhat.com)
- Might be nice if the RHUA RPM actually required grinder.
  (jason.dobies@redhat.com)
- Sort the keys to make sure the list appears in order
  (jason.dobies@redhat.com)
- Updated to newest grinder APIs. (jason.dobies@redhat.com)
- Extra blank line (jason.dobies@redhat.com)

* Mon May 17 2010 Sayli Karmarkar <skarmark@redhat.com> 0.31-1
- instance creation using deltacloud and related config options
  (skarmark@redhat.com)
- Adding deltacloud_ops functions (skarmark@redhat.com)
- reverting last change in rh-rhua.spec and fixing nimbus_setup as the rpm
  unpacking error was actually because of a bug in nimbus_setup
  (skarmark@redhat.com)

* Fri May 14 2010 Sayli Karmarkar <skarmark@redhat.com> 0.30-1
- Modifying spec file for rh-rhua to resolve 
  " unpacking of archive failed on file /etc/rhua/cds/cds_ssl.conf;4bedc1b8: 
    cpio: lstat failed - Not a directory"
 

* Fri May 07 2010 Jay Dobies <jason.dobies@redhat.com> 0.29-1
- Making sure the config change for chain.crt is picked up

* Thu May 06 2010 Jay Dobies <jason.dobies@redhat.com> 0.28-1
- Updated for grinder API changes. (jason.dobies@redhat.com)
- Added all supported DeltaCloud drivers and option for "Unknown" cloud type.
  (jason.dobies@redhat.com)
- Updated incorrect unconfigured error message. (jason.dobies@redhat.com)
- Added chain default name (jason.dobies@redhat.com)

* Wed May 05 2010 Jay Dobies <jason.dobies@redhat.com> 0.27-1
- Automatic commit of package [rh-rhua] release [0.24-1].
  (jason.dobies@redhat.com)
- Forgot to update this (jason.dobies@redhat.com)

* Tue May 04 2010 Jay Dobies <jason.dobies@redhat.com> 0.24-1
- Fixed logic in CDS configure to take into account situations where we both
  know the CDS hostnames ahead of time and those where the hostname will be
  manually applied later. (jason.dobies@redhat.com)
- Added apache restart to end of CDS initialize. (jason.dobies@redhat.com)
- Implemented package synchronization to CDS instances.
  (jason.dobies@redhat.com)
- Added package header (jason.dobies@redhat.com)
- Load the DNS entries from the config if they were not created as part of the
  RHUA start (jason.dobies@redhat.com)
- Added system_ops unit tests (jason.dobies@redhat.com)
- Added CDS autocreate and image ID configuration parameters.
  (jason.dobies@redhat.com)
- Changed signature (jason.dobies@redhat.com)
- Added hostname to bring in line with what rhua config does.
  (jason.dobies@redhat.com)
- Added cloud type as a configuration parameter (jason.dobies@redhat.com)
- Moved config example to reflect that it is an example.
  (jason.dobies@redhat.com)

* Mon May 03 2010 Jay Dobies <jason.dobies@redhat.com> 0.21-1
- Added man page installation to RPM spec. (jason.dobies@redhat.com)
- Initial pass at a man page for the RHUA CLI. (jason.dobies@redhat.com)
- Added missing configure module. Added call to install a pre-built
  configuration file as the RHUA cloud provider configuration.
  (jason.dobies@redhat.com)
- Added configure functionality to interactively prompt the provider for
  configuration options. (jason.dobies@redhat.com)

* Fri Apr 30 2010 Jay Dobies <jason.dobies@redhat.com> 0.17-1
- Removed certificates and systemid that shouldn't be in the RPM.
  (jason.dobies@redhat.com)
- Added developer command for configuring a single CDS instance.
  (jason.dobies@redhat.com)
- Pass in any extra arguments to the called function (jason.dobies@redhat.com)
- CDS configure needs to create dir for packages (jason.dobies@redhat.com)
- Moved CA certificate and chain to provider configuration
  (jason.dobies@redhat.com)
- Implemented CDS remote configuration from the RHUA. (jason.dobies@redhat.com)

* Thu Apr 29 2010 Jay Dobies <jason.dobies@redhat.com> 0.14-1
- Split out RHUA configuration from cloud provider configuration
  (jason.dobies@redhat.com)
- Added hooks to configure CDS instances and start/stop deltacloud.
  (jason.dobies@redhat.com)
- Ripped out cloud specific hooks. These are going to need to be rethought
  based on a conversation with cmorgan. (jason.dobies@redhat.com)
- Minor docs cleanup (jason.dobies@redhat.com)
- Small clean up to the RHUA spec file (jason.dobies@redhat.com)

* Wed Apr 28 2010 Jay Dobies <jason.dobies@redhat.com> 0.10-1
- Added hosted credentials to RHUA RPM. (jason.dobies@redhat.com)
- Fixed annoyance with escaping the single quotes. (jason.dobies@redhat.com)
- YAML typo (jason.dobies@redhat.com)
- Forgot to update the import (jason.dobies@redhat.com)

* Tue Apr 27 2010 Jay Dobies <jason.dobies@redhat.com> 0.8-1
- Many additions; building a test RPM
* Fri Apr 23 2010 Jay Dobies <jason.dobies@redhat.com> 0.6-1
- Testing the spec file

